<script setup>
import { useForm } from '@inertiajs/vue3';
import { ref } from 'vue';
import AppLayout from '@/Layouts/AppLayout.vue';
import AuthenticationCard from '@/Components/AuthenticationCard.vue';
import InputLabel from '@/Components/InputLabel.vue';
import TextInput from '@/Components/TextInput.vue';
import Select from '@/Components/Select.vue';
import Checkbox from '@/Components/Checkbox.vue';
import PrimaryButton from '@/Components/PrimaryButton.vue';
import DangerButton from '@/Components/DangerButton.vue';
import ConfirmationModal from '@/Components/Modals/Confirmation.vue';

const props = defineProps({
    user: {
        type: Object,
        default: {}
    },
    selected_user: {
        type: Object,
        default: {}
    },
    roles: {
        type: Array,
        default: []
    },
});

const updateForm = useForm({
    role: props.selected_user.role,
    is_active: props.selected_user.is_active ? true : false,
});

const deleteForm = useForm({});

const confirmingUpdateUser = ref(false);
const confirmingDeleteUser = ref(false);

const updateUser = () => {
    updateForm.put(route('users.update', props.selected_user.id), {
        preserveScroll: true,
    });

    return false;
};

const deleteUser = () => {
    deleteForm.delete(route('users.destroy', props.selected_user.id));

    return false;
}
</script>

<template>
    <AppLayout :title="'User - ' + props.selected_user.name">
        <div class="flex justify-end mr-3">
            <Link
                type="button"
                :href="route('users.index')"
                class="block text-base font-medium text-sky-500 hover:text-sky-700"
            >
                <font-awesome-icon icon="fa-solid fa-arrow-left-long" /> Return to Users
            </Link>
        </div>

        <AuthenticationCard>
            <h1 class="text-2xl font-bold text-center">User Information</h1>

            <div>
                <InputLabel for="name" value="Name" />
                <TextInput
                    id="name"
                    :value="props.selected_user.name"
                    type="text"
                    class="mt-1 block w-full"
                    disabled
                />
            </div>

            <div class="mt-4">
                <InputLabel for="email" value="Email" />
                <TextInput
                    id="email"
                    :value="props.selected_user.email"
                    type="email"
                    class="mt-1 block w-full"
                    disabled
                />
            </div>

            <div class="mt-4">
                <InputLabel for="business" value="Business" />
                <TextInput
                    id="business"
                    :value="props.selected_user.business"
                    type="text"
                    class="mt-1 block w-full"
                    disabled
                />
            </div>

            <div class="mt-4 mb-4">
                <InputLabel for="role" value="Role" />
                <Select
                    id="role"
                    v-model="updateForm.role"
                    :items="roles"
                    class="w-36"
                    :disabled="props.user.role !== 'admin'"
                />
            </div>

            <div
                v-if="props.user.role === 'admin'"
                class="flex items-center"
            >
                <Checkbox id="is-active" v-model:checked="updateForm.is_active" name="is-active" />

                <div class="ml-2">
                    Active
                </div>
            </div>

            <div
                v-if="props.user.role === 'admin'"
                class="flex items-center justify-end mt-4 space-x-4"
            >
                <PrimaryButton
                    @click="confirmingUpdateUser = true"
                    class="ml-4"
                    :class="{ 'opacity-25': updateForm.processing }"
                    :disabled="updateForm.processing"
                >
                    Update
                </PrimaryButton>
                <DangerButton
                    @click="confirmingDeleteUser = true"
                    class="ml-4"
                    :class="{ 'opacity-25': deleteForm.processing }"
                    :disabled="deleteForm.processing"
                >
                    Delete
                </DangerButton>
            </div>
        </AuthenticationCard>
    </AppLayout>

    <ConfirmationModal
        :showModal="confirmingUpdateUser"
        title="Update User"
        :content="'Are you sure you want to update the user ' + props.selected_user.name + '?'"
        buttonConfirmationType="primary"
        buttonConfirmationText="Update"
        @closeModal="confirmingUpdateUser = false"
        @confirmAction="confirmingUpdateUser = updateUser()"
    />

    <ConfirmationModal
        :showModal="confirmingDeleteUser"
        title="Delete User"
        :content="'Are you sure you want to delete the user ' + props.selected_user.name + '?'"
        buttonConfirmationType="danger"
        buttonConfirmationText="Delete"
        @closeModal="confirmingDeleteUser = false"
        @confirmAction="confirmingDeleteUser = deleteUser(props.selected_user.id)"
    />
</template>
